/**
 * A hook to get, save, update and delete browser cookies through JavaScript
 *
 * @author Pavan Kumar Jadda
 * @since 1.0.0
 */
export default function useCookies(): {
    check: (name: string) => boolean;
    getCookie: (name: string) => string;
    getAllCookies: () => {
        [key: string]: string;
    };
    setCookie: (name: string, value: string, options?: {
        expires?: number | Date;
        path?: string;
        domain?: string;
        secure?: boolean;
        sameSite?: 'Lax' | 'None' | 'Strict';
    }) => void;
    deleteCookie: (name: string, path?: string, domain?: string, secure?: boolean, sameSite?: 'Lax' | 'None' | 'Strict') => void;
    deleteAllCookies: (path?: string, domain?: string, secure?: boolean, sameSite?: 'Lax' | 'None' | 'Strict') => void;
};
